/////////////////////////////////////////////////////////////////////////////           
//                                                                                      
// Created by: Sergey Belovolov                                                         
// Created on: 30.07.04                                                                 
//                                                                                      
/////////////////////////////////////////////////////////////////////////////           
// (C) 2004 Sergey Belovolov                                           
// e-mail: b_sv@mail.ru
/////////////////////////////////////////////////////////////////////////////

#ifndef _HTON_H
#define _HTON_H

#include <vector>

// Template function for turning inside out any type of data
template < typename SwappedType >
inline SwappedType EndianChange( const SwappedType forConv ) 
{
	unsigned int uiSize = sizeof( SwappedType );

	if ( uiSize > 1 )
	{
		// Pump data from input variable into vector
		std::vector < char > vcStraight( ( const char* ) &forConv, 
										 ( const char* )( &forConv + uiSize ) );
		// Copy data in reverse order
		std::vector < char > vcReversed( vcStraight.rbegin(), vcStraight.rend() );

		SwappedType ForReturn;

		memcpy( &ForReturn, &vcReversed[ 0 ], uiSize );

		return ForReturn;
	}

	return forConv;
}

// Host to network conversion
inline unsigned long long htonll( unsigned long long forConv )
{
	return EndianChange( forConv );
}

// Network to host conversion
inline unsigned long long ntohll( unsigned long long forConv )
{
	return EndianChange( forConv );
}

#endif  // _HTON_H
