/////////////////////////////////////////////////////////////////////////////           
//                                                                                      
// Created by: Sergey Belovolov                                                         
// Created on: 18.06.04                                                                 
//                                                                                      
/////////////////////////////////////////////////////////////////////////////           
// (C) 2004 Sergey Belovolov                                           
// e-mail: b_sv@mail.ru
/////////////////////////////////////////////////////////////////////////////

// This file is for debug build only
// I need it for thread-safe mesage output

#include "definitions.h"

#ifdef _WIN32

// Dll StartUp
BOOL APIENTRY DllMain( HANDLE hModule, 
					   DWORD  ul_reason_for_call, 
					   LPVOID lpReserved
					 )
{
	switch ( ul_reason_for_call )
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
	}
	return TRUE;
}

#endif // _WIN32

#ifdef _TRACABLE_E

// Debug output to console
	#ifdef _DEBUG_TO_CONSOLE
std::ostream* ostrptrOutStream = &( std::cerr );
	#else // Debug to file

		#include <fstream>

namespace
{
	// If defined TRACE_FILENAME
	#ifdef TRACE_FILENAME
		// For outputting debug data to file
		std::ofstream ofstrmOutStream( TRACE_FILENAME );
	#else
		// For outputting debug data to file
		std::ofstream ofstrmOutStream( "trace.log" );
	#endif
}

std::ostream* ostrptrOutStream = &ofstrmOutStream;
	#endif // _DEBUG_TO_CONSOLE

// Definitions of global objects
boost::mutex gMutex;

#endif // _TRACABLE_E

#ifdef USE_SSL

// Global variables. Don't redefine 'em!
SPTR_CSSL_CTX ptrCTX( new CSSL_CTX() );

#endif // USE_SSL

