/////////////////////////////////////////////////////////////////////////////           
//                                                                                      
// Created by: Sergey Belovolov                                                         
// Created on: 11.06.04                                                                 
//                                                                                      
/////////////////////////////////////////////////////////////////////////////           
// (C) 2004 Sergey Belovolov                                           
// e-mail: b_sv@mail.ru
/////////////////////////////////////////////////////////////////////////////

#ifndef _IPSTREAM_H
#define _IPSTREAM_H

#include "iipstream.h"
#include "oipstream.h"

namespace IPStream
{
	// Class which joins all the properties of iipstream & oipstream
	class ipstream : public iipstream, public oipstream
	{
	public:
		// Default constructor
		inline ipstream( unsigned short PortNumber = 0, 
						 const std::string& address = "",
						 ETransportProtocol protocol = TP_TCP, 
						 int options = 0, 
						 EDomain domain = D_INET
                          ) : 
		CIPSocket( PortNumber, address, protocol, options, domain 
                   )
		{
			d_cerr( "ipstream constructor." );
			d_cerr_sl( "PortNumber: " ); d_cerr( PortNumber );
			d_cerr_sl( "address: " ); d_cerr( address );
			d_cerr_sl( "protocol: " ); d_cerr( protocol );
			d_cerr_sl( "options: " ); d_cerr( options );
			d_cerr_sl( "domain: " ); d_cerr( domain );
			d_cerr( "" );
		}

#ifdef USE_SSL
        // Default constructor
        inline ipstream( SPTR_CSSL_CTX a_ptrCTX,
                         unsigned short PortNumber, 
                         const std::string& address,
                         int options = 0, 
                         EDomain domain = D_INET
                          ) : 
        CIPSocket( a_ptrCTX, 
                   PortNumber, 
                   address, 
                   options, 
                   domain 
                   )
        {
            d_cerr( "SSL ipstream constructor." );
            d_cerr_sl( "PortNumber: " ); d_cerr( PortNumber );
            d_cerr_sl( "address: " ); d_cerr( address );
            d_cerr_sl( "options: " ); d_cerr( options );
            d_cerr_sl( "domain: " ); d_cerr( domain );
            d_cerr( "" );
        }
#endif // USE_SSL


		// For construction via Accept
		inline ipstream( const CIPSocket& IPS ) : 
		CIPSocket( IPS )
		/*iipstream( IPS ), oipstream( IPS )*/
		{
			d_cerr( "ipstream constructor via Accept." ); d_cerr( "" );
		}
	};
} // namespace IPStream

#endif // _IPSTREAM_H
