/////////////////////////////////////////////////////////////////////////////           
//                                                                                      
// Created by: Sergey Belovolov                                                         
// Created on: 18.06.04                                                                 
//                                                                                      
/////////////////////////////////////////////////////////////////////////////           
// (C) 2004 Sergey Belovolov                                           
// e-mail: b_sv@mail.ru
/////////////////////////////////////////////////////////////////////////////

#ifndef _UDPSERVER_H
#define _UDPSERVER_H

#include "Singleton/Singleton.h"

#include "interfaces/ip_server.h"

#include "interfaces/port_processor.h"

#ifdef _WIN32
#ifdef UDP_EXPORTS
#define UDP_API __declspec(dllexport)
#else
#define UDP_API __declspec(dllimport)
#endif
#endif // _WIN32

namespace IPStream
{
	// Multi-threaded singleton class for processing incoming UDP connections
    class 
    #ifdef _WIN32
    UDP_API 
    #endif // _WIN32
    CUDPServer : public ITIPServer < CUDPServer > 
    {
    private:

        // Section for safety (non-copyable class)
        CUDPServer( const CUDPServer& );
        CUDPServer& operator=( const CUDPServer& );
   
    public:
		// Processing thread
		virtual void AcceptThread( ipstream );
		
		explicit CUDPServer();
        virtual ~CUDPServer();

    };

	typedef TCSingleton < CUDPServer > UDPServer;

} // namespace IPStream

#endif // _UDPSERVER_H
