/////////////////////////////////////////////////////////////////////////////           
//                                                                                      
// Created by: Sergey Belovolov                                                         
// Created on: 16.06.04                                                                 
//                                                                                      
/////////////////////////////////////////////////////////////////////////////           
// (C) 2004 Sergey Belovolov                                           
// e-mail: b_sv@mail.ru
/////////////////////////////////////////////////////////////////////////////

#include "Processor_Impl.h"

#include "ipstream/ipstream.h"

#include "SerialArray.h"

// Implementation of processing via ipstreambuf
// Call processing
void Processor_Impl::operator()( IPStream::ipstream& ipstrm )
{
	// Link stream for avoiding blocking parent thread inside this function
	Link( ipstrm );

	IPStream::ipstreambuf ipstrbufBuffer;

	int iArr[ 5 ];
	std::string strRcv;

	while ( ipstrbufBuffer.Empty() && !ToStop() )
		ipstrm >> ipstrbufBuffer;

	if ( !( ipstrbufBuffer.Empty() || ToStop() ) )
		ipstrbufBuffer >> iArr;
	
	while ( ipstrbufBuffer.Empty() && !ToStop() )
		ipstrm >> ipstrbufBuffer;

	if ( !( ipstrbufBuffer.Empty() || ToStop() ) )
	{
		ipstrbufBuffer >> strRcv;

		if ( !strRcv.empty() )
			d_cerr( strRcv );
	}

	if ( !ToStop() )
	{
		ipstrbufBuffer.Clear();

		ipstrbufBuffer << iArr << strRcv;

		// Loop back
		ipstrm << ipstrbufBuffer;
	}
}

