/////////////////////////////////////////////////////////////////////////////           
//                                                                                      
// Created by: Sergey Belovolov                                                         
// Created on: 17.06.04                                                                 
//                                                                                      
/////////////////////////////////////////////////////////////////////////////           
// (C) 2004 Sergey Belovolov                                           
// e-mail: b_sv@mail.ru
/////////////////////////////////////////////////////////////////////////////

#include "ipstream/ipstream.h"

#include "boost_adopt/boost_adopt.h"

#include <iostream>
#include <strstream>

#include "../port_processors/SerialArray.h"

#define CAFILE "/opt/rootCA/rootcert.pem"
#define CERTFILECLI "/opt/rootCA/certs/client.pem"
#define CERTPASSWD "Taiwan"

using namespace std;

int main()
{
	STARTUP;

	SSL_STARTUP_CLIENT( CAFILE, CERTFILECLI, CERTPASSWD );

	while ( true )
	{

#ifdef USE_SSL
		IPStream::ipstream ipstrmTmp( ptrCTX, 6081, "127.0.0.1" );
		IPStream::ipstream ipstrmTmp1( ptrCTX, 6082, "127.0.0.1" );
		IPStream::ipstream ipstrmTmp2( ptrCTX, 6083, "127.0.0.1" );
#else
		IPStream::ipstream ipstrmTmp( 6081, "127.0.0.1", IPStream::TP_TCP );
		IPStream::ipstream ipstrmTmp1( 6082, "127.0.0.1", IPStream::TP_TCP );
		IPStream::ipstream ipstrmTmp2( 6083, "127.0.0.1", IPStream::TP_TCP );
#endif

		if ( ipstrmTmp.Connect() && ipstrmTmp.good() && ipstrmTmp1.Connect() && 
			 ipstrmTmp1.good() && ipstrmTmp2.Connect() && ipstrmTmp2.good() )
		{
			cout << "Sockets were created and connected successfully..." << endl;

			// Data for transmission testing
			int iArr[ 5 ];
			int iArrSend[ 5 ] = { 1976, 1977, 1978, 1979, 2004};
			std::string strRcv;
			std::string strSend = "Ars longa vita brevis!";

			// Sending data
			ipstrmTmp << iArrSend << strSend;
			ipstrmTmp1 << iArrSend << strSend;
			ipstrmTmp2 << iArrSend << strSend;

			strRcv.clear();

			ipstrmTmp >> iArr >> strRcv;

			if ( strRcv.empty() || ( strSend != strRcv ) )
			{
				cout << "Transmition via ipstreambuf failed..." << endl;
				return -1;
			}

			cout << "Transmition via ipstreambuf Ok..." << endl;

			strRcv.clear();

			ipstrmTmp1 >> iArr >> strRcv;

			if ( strRcv.empty() || ( strSend != strRcv ) )
			{
				cout << "Transmition via operators << and >> failed..." << endl;
				return -1;
			}

			cout << "Transmition via operators << and >> Ok..." << endl;

			strRcv.clear();

			ipstrmTmp2 >> iArr >> strRcv;

			if ( strRcv.empty() || ( strSend != strRcv ) )
			{
				cout << "Transmition via Send/Recv failed..." << endl;
				return -1;
			}

			cout << "Transmition via Send/Recv Ok..." << endl;

			// Reopen sockets
			if ( ipstrmTmp.Open() && ipstrmTmp1.Open() && ipstrmTmp2.Open() )
			{
				cout << "Sockets were successfully reopened..." << endl;
			}
			else
			{
				cout << "Sockets reopen failed..." << endl;
				return -1;
			}

#ifdef USE_SSL

			// New streams at the same ports
			IPStream::ipstream ipstrmTmp_( ptrCTX, 
										   6081, 
										   "127.0.0.1" );
			IPStream::ipstream ipstrmTmp1_( ptrCTX, 
											6082, 
											"127.0.0.1" );
			IPStream::ipstream ipstrmTmp2_( ptrCTX, 
											6083, 
											"127.0.0.1" );
#else

			// New streams at the same ports
			IPStream::ipstream ipstrmTmp_( 6081, "127.0.0.1", IPStream::TP_TCP );
			IPStream::ipstream ipstrmTmp1_( 6082, "127.0.0.1", IPStream::TP_TCP );
			IPStream::ipstream ipstrmTmp2_( 6083, "127.0.0.1", IPStream::TP_TCP );
#endif

			// Connect them
			if ( ipstrmTmp.Connect() && ipstrmTmp.good() && ipstrmTmp1.Connect() && 
				 ipstrmTmp1.good() && ipstrmTmp2.Connect() && ipstrmTmp2.good() && 
				 ipstrmTmp_.Connect() && ipstrmTmp_.good() && ipstrmTmp1_.Connect() && 
				 ipstrmTmp1_.good() && ipstrmTmp2_.Connect() && ipstrmTmp2_.good() )
			{
				cout << "Twin sockets were created and connected successfully..." << endl;

				// Sending data
				ipstrmTmp << iArrSend << strSend;
				ipstrmTmp1 << iArrSend << strSend;
				ipstrmTmp2 << iArrSend << strSend;
				// Sending data via twins
				ipstrmTmp_ << iArrSend << strSend;
				ipstrmTmp1_ << iArrSend << strSend;
				ipstrmTmp2_ << iArrSend << strSend;

				strRcv.clear();

				ipstrmTmp >> iArr >> strRcv;

				if ( strRcv.empty() || ( strSend != strRcv ) )
				{
					cout << "Twin first transmition via ipstreambuf failed..." << endl;
					return -1;
				}

				cout << "Twin first transmition via ipstreambuf Ok..." << endl;

				strRcv.clear();

				ipstrmTmp1 >> iArr >> strRcv;

				if ( strRcv.empty() || ( strSend != strRcv ) )
				{
					cout << "Twin first transmition via operators << and >> failed..." << endl;
					return -1;
				}

				cout << "Twin first transmition via operators << and >> Ok..." << endl;

				strRcv.clear();

				ipstrmTmp2 >> iArr >> strRcv;

				if ( strRcv.empty() || ( strSend != strRcv ) )
				{
					cout << "Twin first transmition via Send/Recv failed..." << endl;
					return -1;
				}

				cout << "Twin first transmition via Send/Recv Ok..." << endl;

				// Now second twins
				strRcv.clear();

				ipstrmTmp_ >> iArr >> strRcv;

				if ( strRcv.empty() || ( strSend != strRcv ) )
				{
					cout << "Twin second transmition via ipstreambuf failed..." << endl;
					return -1;
				}

				cout << "Twin second transmition via ipstreambuf Ok..." << endl;

				strRcv.clear();

				ipstrmTmp1_ >> iArr >> strRcv;

				if ( strRcv.empty() || ( strSend != strRcv ) )
				{
					cout << "Twin second transmition via operators << and >> failed..." << endl;
					return -1;
				}

				cout << "Twin second transmition via operators << and >> Ok..." << endl;

				strRcv.clear();

				ipstrmTmp2_ >> iArr >> strRcv;

				if ( strRcv.empty() || ( strSend != strRcv ) )
				{
					cout << "Twin second transmition via Send/Recv failed..." << endl;
					return -1;
				}

				cout << "Twin second transmition via Send/Recv Ok..." << endl;

				// Reopen sockets
				if ( ipstrmTmp.Open() && ipstrmTmp1.Open() && ipstrmTmp2.Open() &&
					 ipstrmTmp_.Open() && ipstrmTmp1_.Open() && ipstrmTmp2_.Open() )
				{
					cout << "Sockets were successfully reopened..." << endl;
				}
				else
				{
					cout << "Sockets reopen failed..." << endl;
					return -1;
				}

				// Connect them
				if ( ipstrmTmp.Connect() && ipstrmTmp.good() && ipstrmTmp1.Connect() && 
					 ipstrmTmp1.good() && ipstrmTmp2.Connect() && ipstrmTmp2.good() && 
					 ipstrmTmp_.Connect() && ipstrmTmp_.good() && ipstrmTmp1_.Connect() && 
					 ipstrmTmp1_.good() && ipstrmTmp2_.Connect() && ipstrmTmp2_.good() )
				{
					cout << "Twin sockets were reconnected successfully..." << endl;

					// Pump our output string
					strstream OutStream;

					for ( unsigned int uiCount = 0; uiCount < 1000 ; ++uiCount )
						OutStream << strSend;

					// Put end of line
					OutStream << ends;

					strSend = OutStream.str(); 

					// Sending data
					ipstrmTmp << iArrSend << strSend;
					ipstrmTmp1 << iArrSend << strSend;
					ipstrmTmp2 << iArrSend << strSend;
					// Sending data via twins
					ipstrmTmp_ << iArrSend << strSend;
					ipstrmTmp1_ << iArrSend << strSend;
					ipstrmTmp2_ << iArrSend << strSend;

					strRcv.clear();

					ipstrmTmp >> iArr >> strRcv;

					if ( strRcv.empty() || ( strSend != strRcv ) )
					{
						cout << "Twin first big block transmition via ipstreambuf failed..." << endl;
						return -1;
					}

					cout << "Twin first big block transmition via ipstreambuf Ok..." << endl;

					strRcv.clear();

					ipstrmTmp1 >> iArr >> strRcv;

					if ( strRcv.empty() || ( strSend != strRcv ) )
					{
						cout << "Twin first big block transmition via operators << and >> failed..." 
							<< endl;
						return -1;
					}

					cout << "Twin first big block transmition via operators << and >> Ok..." << endl;

					strRcv.clear();

					ipstrmTmp2 >> iArr >> strRcv;

					if ( strRcv.empty() || ( strSend != strRcv ) )
					{
						cout << "Twin first big block transmition via Send/Recv failed..." << endl;
						return -1;
					}

					cout << "Twin first big block transmition via Send/Recv Ok..." << endl;

					// Now second twins
					strRcv.clear();

					ipstrmTmp_ >> iArr >> strRcv;

					if ( strRcv.empty() || ( strSend != strRcv ) )
					{
						cout << "Twin second big block transmition via ipstreambuf failed..." << endl;
						return -1;
					}

					cout << "Twin second big block transmition via ipstreambuf Ok..." << endl;

					strRcv.clear();

					ipstrmTmp1_ >> iArr >> strRcv;

					if ( strRcv.empty() || ( strSend != strRcv ) )
					{
						cout << "Twin second big block transmition via operators << and >> failed..." 
							<< endl;
						return -1;
					}

					cout << "Twin second big block transmition via operators << and >> Ok..." << endl;

					strRcv.clear();

					ipstrmTmp2_ >> iArr >> strRcv;

					if ( strRcv.empty() || ( strSend != strRcv ) )
					{
						cout << "Twin second big block transmition via Send/Recv failed..." << endl;
						return -1;
					}

					cout << "Twin second big block transmition via Send/Recv Ok..." << endl << endl;

					cout << "All the tests were passed successfully..." << endl;
				}
				else
				{
					cout << "Twin sockets reconnection failed..." << endl;
					return -1;
				}

			}
			else
			{
				cout << "Twin sockets creation and connection failed..." << endl;
				return -1;
			}
		}
		else
		{
			cout << "Sockets creation and connection failed..." << endl;
			cout << "Make shure that there are no applications which use ports 6081, 6082, 6083..." 
				<< endl;

			return -1;
		}

	}//while(true)

	SSL_SUTDOWN;

	CLEANUP;

	boost_adopt::sleep( 5 );

	return 0;
}
