/////////////////////////////////////////////////////////////////////////////           
//                                                                                      
// Created by: Sergey Belovolov                                                         
// Created on: 12.06.04                                                                 
//                                                                                      
/////////////////////////////////////////////////////////////////////////////           
// (C) 2004 Sergey Belovolov                                           
// e-mail: b_sv@mail.ru
/////////////////////////////////////////////////////////////////////////////

#include "servers/tcp/TCPServer.h"

#include "../port_processors/Processor_Impl.h"
#include "../port_processors/Processor_Impl1.h"
#include "../port_processors/Processor_Impl2.h"

#include "boost_adopt/boost_adopt.h"

#define CAFILE "/opt/rootCA/rootcert.pem"
#define CERTFILESERV "/opt/rootCA/certs/server.pem"
#define CERTPASSWD "Taiwan"
#define DHMINOR "/opt/rootCA/certs/dh512.pem"
#define DHMAJOR "/opt/rootCA/certs/dh1024.pem"

int main()
{
	STARTUP;

    IPStream::CTCPServer& tcpsrvInst = IPStream::TCPServer::CreateInstance();

	// Initialize SSL if we need it
    SSL_STARTUP_SERVER( tcpsrvInst, CAFILE, CERTFILESERV, CERTPASSWD, DHMINOR, DHMAJOR );

	Processor_Impl1 prcMy;
	Processor_Impl1 prcMy1;
	Processor_Impl1 prcMy2;

    tcpsrvInst.AddProcessor( 6081, &prcMy );
	tcpsrvInst.AddProcessor( 6082, &prcMy1 );
	tcpsrvInst.AddProcessor( 6083, &prcMy2 );

    tcpsrvInst.Start();

    // Sleep for 20 seconds
	boost_adopt::sleep( 10/*000*/ );

	tcpsrvInst.Stop();

	SSL_SUTDOWN;

	CLEANUP;

	return 0;
}
