/////////////////////////////////////////////////////////////////////////////           
//                                                                                      
// Created by: Sergey Belovolov                                                         
// Created on: 24.06.04                                                                 
//                                                                                      
/////////////////////////////////////////////////////////////////////////////           
// (C) 2004 Sergey Belovolov                                           
// e-mail: b_sv@mail.ru
/////////////////////////////////////////////////////////////////////////////

#include "ipstream/ipstream.h"

#include "boost_adopt/boost_adopt.h"

#include "../port_processors/SerialArray.h"

#include <iostream>
#include <strstream>

using namespace std;

int main()
{
	STARTUP;

	IPStream::ipstream ipstrmTmp( 6084, "127.0.0.1", IPStream::TP_UDP );
	IPStream::ipstream ipstrmTmp1( 6085, "127.0.0.1", IPStream::TP_UDP );
	IPStream::ipstream ipstrmTmp2( 6086, "127.0.0.1", IPStream::TP_UDP );
	IPStream::ipstream ipstrmTmp3( 6087, "127.0.0.1", IPStream::TP_UDP );

	if ( ipstrmTmp.good() && ipstrmTmp1.good() && ipstrmTmp2.good() &&
		 ipstrmTmp3.Connect() && ipstrmTmp3.good() )
	{
		cout << "Sockets were created successfully..." << endl;

		// Data for transmission testing
		int iArr[ 5 ];
		int iArrSend[ 5 ] = { 1970, 1977, 1978, 1979, 2003};
		std::string strRcv;
		std::string strSend = "Ducunt volentem fata, nolentem trahunt!";

		// Sending data
		ipstrmTmp << iArrSend << strSend;
		ipstrmTmp1 << iArrSend << strSend;
		ipstrmTmp2 << iArrSend << strSend;
		ipstrmTmp3 << iArrSend << strSend;

		strRcv.clear();

		ipstrmTmp >> iArr >> strRcv;

		if ( strRcv.empty() || ( strSend != strRcv ) )
		{
			cout << "Transmition via ipstreambuf failed..." << endl;
			return -1;
		}

		cout << "Transmition via ipstreambuf Ok..." << endl;

		strRcv.clear();

		ipstrmTmp1 >> iArr >> strRcv;

		if ( strRcv.empty() || ( strSend != strRcv ) )
		{
			cout << "Transmition via operators << and >> failed..." << endl;
			return -1;
		}

		cout << "Transmition via operators << and >> Ok..." << endl;

		strRcv.clear();

		ipstrmTmp2 >> iArr >> strRcv;

		if ( strRcv.empty() || ( strSend != strRcv ) )
		{
			cout << "Transmition via Send/Recv failed..." << endl;
			return -1;
		}

		cout << "Transmition via Send/Recv Ok..." << endl;

		strRcv.clear();

		ipstrmTmp3 >> iArr >> strRcv;

		if ( strRcv.empty() || ( strSend != strRcv ) )
		{
			cout << "Transmition via connected UDP-socket failed..." << endl;
			return -1;
		}

		cout << "Transmition via connected UDP-socket Ok..." << endl;

		// Sleep for 20 seconds
		//boost_adopt::sleep( 5, 200000000 );

		// Reopen socket
		if ( ipstrmTmp.Open() && ipstrmTmp1.Open() && 
			 ipstrmTmp2.Open() && ipstrmTmp3.Open() )
		{
			cout << "Connected socket was successfully reopened..." << endl;
		}
		else
		{
			cout << "Connected socket reopen failed..." << endl;
			return -1;
		}

		// Connect them
		if ( ipstrmTmp3.Connect() && ipstrmTmp3.good() && ipstrmTmp.good() &&
			 ipstrmTmp1.good() && ipstrmTmp2.good() )
		{
			cout << "Socket was reconnected successfully..." << endl;
	
//////
			// Pump our output string
			strstream OutStream;

			for ( unsigned int uiCount = 0; uiCount < 1000 ; ++uiCount )
				OutStream << strSend;

			// Put end of line
			OutStream << ends;

			strSend = OutStream.str(); 

			// Sending data
			ipstrmTmp << iArrSend << strSend;
			ipstrmTmp1 << iArrSend << strSend;
			ipstrmTmp2 << iArrSend << strSend;
			ipstrmTmp3 << iArrSend << strSend;

			boost_adopt::sleep( 0, 200000000 );

			strRcv.clear();

 			ipstrmTmp >> iArr >> strRcv;

			if ( strRcv.empty() || ( strSend != strRcv ) )
			{
				cout << "Big block transmition via ipstreambuf failed..." << endl;
				return -1;
			}

			cout << "Big block transmition via ipstreambuf Ok..." << endl;

			strRcv.clear();

			ipstrmTmp1 >> iArr >> strRcv;

			if ( strRcv.empty() || ( strSend != strRcv ) )
			{
				cout << "Big block transmition via operators << and >> failed..." 
					<< endl;
				return -1;
			}

			cout << "Big block transmition via operators << and >> Ok..." << endl;

			strRcv.clear();

			ipstrmTmp2 >> iArr >> strRcv;

			if ( strRcv.empty() || ( strSend != strRcv ) )
			{
				cout << "Big block transmition via Send/Recv failed..." << endl;
				return -1;
			}

			cout << "Big block transmition via Send/Recv Ok..." << endl;

			strRcv.clear();

			ipstrmTmp3 >> iArr >> strRcv;

			if ( strRcv.empty() || ( strSend != strRcv ) )
			{
				cout << "Big block transmition via connected UDP-socket failed..." << endl;
				return -1;
			}

			cout << "Big block transmition via connected UDP-socket Ok..." << endl << endl;

			cout << "All the tests were passed successfully..." << endl;
//////
		}
		else
		{
			cout << "Sockets reconnection failed..." << endl;
			return -1;
		}
	}
	else
	{
		cout << "Sockets creation failed..." << endl;
		cout << "Make shure that there are no applications which use ports 6084, 6085, 6086 and 6087..." 
			<< endl;

		return -1;
	}

	CLEANUP;

	boost_adopt::sleep( 20 );

	return 0;
}
