/////////////////////////////////////////////////////////////////////////////           
//                                                                                      
// Created by: Sergey Belovolov                                                         
// Created on: 24.06.04                                                                 
//                                                                                      
/////////////////////////////////////////////////////////////////////////////           
// (C) 2004 Sergey Belovolov                                           
// e-mail: b_sv@mail.ru
/////////////////////////////////////////////////////////////////////////////

#include "servers/udp/UDPServer.h"

#include "../port_processors/Processor_Impl.h"
#include "../port_processors/Processor_Impl1.h"
#include "../port_processors/Processor_Impl2.h"
#include "UDPConn_Processor.h"

#include "boost_adopt/boost_adopt.h"

int main()
{
	STARTUP;

	IPStream::CUDPServer& udpsrvInst = IPStream::UDPServer::CreateInstance();
	
	Processor_Impl prcMy;
	Processor_Impl1 prcMy1;
	Processor_Impl2 prcMy2;
	UDPConn_Processor prcUDPConn;

	udpsrvInst.AddProcessor( 6084, &prcMy );
	udpsrvInst.AddProcessor( 6085, &prcMy1 );
	udpsrvInst.AddProcessor( 6086, &prcMy2 );
	udpsrvInst.AddProcessor( 6087, &prcUDPConn );

	udpsrvInst.Start();

    // Sleep for 20 seconds
	//boost_adopt::sleep( 120 );
	while ( 1 )
		boost_adopt::sleep( 120 );

	udpsrvInst.Stop();
    
	CLEANUP;

	return 0;
}
